/**
 * 缓存函数调用结果
 *
 * @param {function} fn - 函数
 */
export function memoize(fn) {
    var cachedArg;
    var cachedResult;
    return function (arg) {
        if (cachedArg === arg)
            return cachedResult;
        cachedArg = arg;
        cachedResult = fn(arg);
        return cachedResult;
    };
}
